[package]
name = "polymer"
authors = ["Josh Robson Chase <josh@robsonchase.com>"]
version = "0.2.0"
license = "MIT/Apache-2.0"
description = "Modular keyboard firmware."
documentation = "https://docs.rs/polymer"
homepage = "https://gitlab.com/polymer-kb/polymer"
repository = "https://gitlab.com/polymer-kb/firmware/polymer"
edition = "2018"

[dependencies]
alloc-cortex-m = "0.4.0"
panic-semihosting = { version = "0.5.4", optional = true }
panic-abort = "0.3.2"
panic-itm = { version = "0.4.1", optional = true }

nb = "1.0.0"
lock_api = "0.4.1"
pin-utils = "0.1.0"
either = { version = "1.6.1", default-features = false }
cortex-m-rt = "0.6.13"
cortex-m = "0.6.3"
stm32-usbd = "0.5.1"
usb-device = "0.2.7"
keebrs = "0.3.0"
newtype = "0.2.1"
embedded-hal = "0.2.4"
cortex-m-async = "0.1.0"
futures-intrusive = { version = "0.3.1", default-features = false }
cortex-m-rtic = "0.5.5"
cortex-m-logger = "0.0.0-alpha.1"
log = { version = "0.4.11", default-features = false }

[dependencies.embedded-executor]
version = "0.6.1"
default-features = false
features = ["alloc"]

[dependencies.stm32f1xx-futures]
version = "0.1.0"
features = ["stm32f103", "stm32-usbd"]

[dependencies.futures]
version = "0.3.7"
default-features = false

[[bin]]
name = "polymer"
test = false
bench = false

[profile.dev]
codegen-units = 1

[profile.dev.package."*"]
codegen-units = 1
opt-level = "z"

[profile.release]
debug = true
lto = true
codegen-units = 1
opt-level = "z"

[profile.release.package."*"]
codegen-units = 1
opt-level = "z"

[features]
itm = ["panic-itm"]
semihosting = ["panic-semihosting", "cortex-m-logger/semihosting"]
log_off = ["log/release_max_level_off"]
log_trace = ["log/release_max_level_trace"]
log_debug = ["log/release_max_level_debug"]
log_info = ["log/release_max_level_info"]
log_warn = ["log/release_max_level_warn"]
log_error = ["log/release_max_level_error"]
default = ["log_off"]

[patch.crates-io]
# embedded-executor = { path = "../embedded-executor" }
#stm32f1xx-futures = { path = "../stm32f1xx-futures" }
#keebrs = { path = "../keebrs" }
#cortex-m-async = { path = "../cortex-m-async" }